;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; This file is part of ARYAN.
;;
;; Ayan is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
;;
;; Aryan  is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along with Foobar. If not, see https://www.gnu.org/licenses/.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

.include "cpctelera.h.s"
.include "entity_struct.inc"
.globl _entity_jugador
.globl _entity_enemigos
.globl _entity_update_pos
.globl _num_enemies
.globl _act_enemy
.globl _entity_ataque
.globl sabernivel
.globl _posicion_jugador

.globl actualenemigo
colisiones_init::

    ld hl,#_entity_jugador
    call sabernivel
    call comprobar_posicion_tile
    ex de,hl
    ld hl,#_posicion_jugador
    ld (hl),d
    inc hl
    ld (hl),e
    call recorretileene

ret 
colisionata::

    ld hl,#_entity_ataque
    call sabernivel
    call comprobar_posicion_tile
    ex de,hl
    ld hl,#_entity_ataque
    ld bc,#0x0004
    add hl,bc
    ld (hl),d
    inc hl
    ld (hl),e

ret
comprobar_posicion_tile:
    push de
    inc hl ;x
    ld a,(hl)
    srl a
    srl a
    ld c,a
    ld b,#0

    inc hl;y
    ld a,(hl)
    and #0b11111000
    ld e,a
    srl e
    ld d,b
    ld l,a    
    ld h,d
    add hl,hl
    add hl,de
    add hl,bc
    ex de,hl
    pop hl
    add hl,de
ret 

recorretileene:
    ld hl,#_num_enemies
    ld a ,(hl)
    or a
    jp z,final
    ld d,a
    xor a
    ld c,#0
    bucleen:
    ld a,c
    ld hl,#_act_enemy
    ld (hl),a
    push de
    call tilene
    pop de
    ld hl,#_act_enemy
    ld a,(hl)
    ld bc,#TAM_ENTITY_ENEMIGO_TOTAL
    add a,c
    ld c,a
    dec d
    ld a,d
    or a
    jp nz,bucleen
ret

tilenedis::
    call actualenemigo
    ld de,#0x0007
    add hl,de
    call sabernivel
    call comprobar_posicion_tile
    ex de,hl
    push de
    call actualenemigo
    pop de
    ld bc,#0x000A
    add hl,bc
    ld (hl),d
    inc hl
    ld (hl),e

ret
tilene:
    call actualenemigo
    call sabernivel
    call comprobar_posicion_tile
    ex de,hl
    push de
    call actualenemigo
    pop de
    ld bc,#0x000A
    add hl,bc
    ld (hl),d
    inc hl
    ld (hl),e

ret
    final:

    ret