;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; This file is part of ARYAN.
;;
;; Ayan is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
;;
;; Aryan  is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along with Foobar. If not, see https://www.gnu.org/licenses/.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

.include "cpctelera.h.s"

.area _DATA

.globl cpct_scanKeyboard_asm
.globl cpct_isKeyPressed_asm
.globl cpct_disableFirmware_asm
;.globl sys_renderBlended
;.globl sys_renderBlended_enemigo
.globl sys_init_entidades
.globl sys_render_update
.globl  sys_render_init           
.globl sys_entity_update
.globl cpct_waitVSYNC_asm
.globl _init
.globl sys_render_init
.globl detectatecla
.globl recorrerEne
.globl recorrerEnecol
.globl actuatack
.globl colisiones_init
.globl personajecol
.globl render_inicio
.globl nivel1
.globl sys_render_update_borrado
.globl cpct_akp_musicPlay_asm
.globl musica_init_menu
.globl init_nivel
.globl _entity_jugador
.globl comprobar_partida
.globl musica_stop
.globl render_continue
.globl nivel_fin
;.globl change_buffer

.include "entity_struct.inc"
.area _CODE

contador: .db 06
inthandler::
   push af
   push de
   push bc
   push hl
   ld a,(contador)
   dec a
   jp nz,nocero
   cero:
   call cpct_akp_musicPlay_asm
   ld a,#6
   nocero:
   ld (contador),a
   pop hl
   pop bc
   pop de
   pop af

   ei
   reti
setHandler:
   ld hl,#0x38
   ld (hl),#0xc3
   inc hl
   ld (hl),#<inthandler
   inc hl
   ld (hl), #>inthandler
   inc hl
   ld (hl),#0xc9
   ret
_main::
   call cpct_disableFirmware_asm
   call musica_init_menu
   call setHandler
   call sys_render_init
   call sys_render_init           
   call render_inicio
   start_nivel:
      call cpct_scanKeyboard_asm
      ld hl,#Key_Return
      call cpct_isKeyPressed_asm
      jr nz,level1
      jr start_nivel

   level1:
   call musica_stop
      call  nivel1
      call init_nivel
loop:                          ;; BUCLE PRINCIPAL JUEGO 
   call comprobar_partida
   cp #0xff
   jp z,finpartida               
   call detectatecla                ;detecta el techado o el joy para hacer que el personaje se mueva o ataque 

   call recorrerEne                 ; recorre enemigos para moverlos hacer que ataquen  y roten
   call recorrerEnecol              ;recorre enemigos para comprobar si reciben daño bajarles la vida y matarlos cuando no les quede vida
   call personajecol                ;comprueba todos los proyectiles y enemigos para hacer que el  personaje reciba dano y si es letal matarlo
   call sys_entity_update
   call actuatack                   ;comprueba si hay un ataque de personaje y le baja el tiempo si este tiempo llega a 0 elimina el ataque
   call cpct_waitVSYNC_asm
   call sys_render_update
   ld hl,#_entity_jugador
   ld a,(hl)
   cp #0xff
   jr nz,  loop                     ;comprueba si el enemigo esta vivo si no lo esta acaba la partida
   jp finpartida

   finpartida:
   call nivel_fin
   call render_continue
   call init_nivel

   contpartida:
   call cpct_scanKeyboard_asm
      ld hl,#Key_Return
      call cpct_isKeyPressed_asm
      jr nz,level1
   jp contpartida


   