;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; This file is part of ARYAN.
;;
;; Ayan is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
;;
;; Aryan  is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along with Foobar. If not, see https://www.gnu.org/licenses/.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


.include "cpctelera.h.s"
.include "sprites/assets.inc"
.include "entity_struct.inc"
.globl _nivel
.globl cpct_scanKeyboard_asm
.globl cpct_isKeyPressed_asm
.globl cpct_isAnyKeyPressed_asm
.globl entity_update_vida
.globl cambiar_anim_entity_jugador
.globl cambiar_anim_entity_enemigo
.globl render_fondo_borrado_vida
.globl render_fondo_borrado
.globl render_fondo_borrado_slime
.globl _entity_jugador
.globl _entity_enemigos
.globl _entity_update_pos
.globl _num_enemies
.globl _act_enemy
.globl _entity_ataque
.globl _posicion_jugador
.globl colisionata
.globl tilenedis
.globl damage_live_enemies
.globl render_fondo_borrado_shot
.area _DATA
.globl _buclee
entrar   =  0

.area _CODE

_init::
   ld ix,#-2
   ld entrar(ix),#8
   ld a,#0
   ld (_buclee),a

ret
actmirar:
   ld hl,#_entity_jugador
   ld de,#5
   add hl,de
   ld (hl),b
ret
actmirarene:
   call actualenemigo
   ld de,#5
   add hl,de
   ld (hl),b
ret
detectatecla::
   ld hl,#_entity_jugador
   ld de,#0x0006
   add hl,de
   ld a,(hl)
   or a
   jp z,sigo
      dec a
      ld (hl),a
   sigo:


   ld hl ,#_entity_ataque
   ld a,(hl)
   cp #0xFF
   jp nz,final
   call cpct_scanKeyboard_asm
   ld hl,#Key_CursorRight
   call cpct_isKeyPressed_asm
   jp nz, derr
   ld hl,#Joy0_Right
   call cpct_isKeyPressed_asm
   jp z, s1
   derr:
   call derecha
   jp s1
   s1:
   ld hl,#Key_CursorLeft
   call cpct_isKeyPressed_asm
   jp nz, izqq
   ld hl,#Joy0_Left
   call cpct_isKeyPressed_asm
   jp z, s2
   izqq:
   call izquierda
   jp s2
  
   s2:
   ld hl,#Key_CursorUp
   call cpct_isKeyPressed_asm
   jp nz, ar
   ld hl,#Joy0_Up
   call cpct_isKeyPressed_asm
   jp z, s3
   ar:
   call arriba
   s3:
   ld hl,#Key_CursorDown
   call cpct_isKeyPressed_asm
   jp nz, ab
   ld hl,#Joy0_Down
   call cpct_isKeyPressed_asm
   jp z, s4
   ab:
   call bajo
   s4:
   ld hl,#Joy0_Fire1
   call cpct_isKeyPressed_asm
   jp nz, ata
   ld hl,#Joy0_Fire2
   call cpct_isKeyPressed_asm
   jp nz, ata
   ld hl,#Key_Space
   call cpct_isKeyPressed_asm
   jp z, final
   ata:
   call compatack
   jp final
      
   derecha:
   
      ld a ,#0
      ld bc,#0x0001
      call posicionsigtile
      ld a,(hl)
      cp #0
      jp nz,final


      ld a ,#0
      ld bc,#0x0002
      call posicionsigtile
      ld a,(hl)
      cp #0
      jp nz,compder
       ld a ,#0
      ld bc,#0x0016
      call posicionsigtile
      ld a,(hl)
      cp #0
      jp nz,compder
      ld hl ,#_entity_jugador
      inc hl
      inc hl
      ld a,(hl)
      dec a
      dec a
      and #0b00000111
      or a
      jp z, si2
      ld hl ,#_entity_jugador
      inc hl
      inc hl
      ld a,(hl)
      and #0b00000111
      or a
      jp nz, si
      si2:
      ld a ,#1
      ld bc,#0x0012
      call posicionsigtile      
      ld a,(hl)
      cp #0
      jp nz,compder
      si:
       ld hl ,#_entity_jugador
      inc hl
      inc hl
      ld a,(hl)
      inc a
      inc a

      and #0b00000111
      or a
      jp nz, derrr
      ld a ,#0
      ld bc,#0x002A
      call posicionsigtile
      ld a,(hl)
      cp #0
      jp z,derrr
      compder:
      ld hl,#_entity_jugador
      inc hl
      ld a,(hl)
      inc a
      and #0b00000011
      or a
      jp z,final
      
      ; ld a ,#0
      ; ld bc,#0x0030
      ; call posicionsigtile
      ; ld a,(hl)
      ; cp #0
      ; jp nz,final
      derrr:

      ld hl, #_entity_jugador
      ld e ,#0 ;y
      ld d, #1 ;x
      ld c,#0x48
      call _entity_update_pos
      push af
      call mirar
      cp #2
      jp z,noactuder
      ld b,#2
      call actmirar
      call cambiar_anim_entity_jugador

      noactuder:
      pop af
      cp #0xff
      jp nz,final
      ld hl,#_entity_jugador
      inc hl
      ld a,(hl)
      and #0b00000011
      or a
      jp nz, final
      ld a,#1
      call actualiztilemas
   ret
   izquierda:
      ld hl ,#_entity_jugador
      inc hl
      ld a,(hl)
      and #0b00000011
      or a
      jp nz, pasarr
      ld a ,#1
      ld bc,#0x0001
      call posicionsigtile
      ld a,(hl)
      cp #0
      jp nz,final
      ld hl ,#_entity_jugador
      inc hl
      inc hl
      ld a,(hl)
      dec a
      dec a

      and #0b00000111
      or a
      jp z, sig2
      ld hl ,#_entity_jugador
      inc hl
      inc hl
      ld a,(hl)
      and #0b00000111
      or a
      jp nz, sig
      sig2:
      ld a ,#1
      ld bc,#0x0015
      call posicionsigtile
      ld a,(hl)
      cp #0
      jp nz,final
      sig:
      ld a ,#0
      ld bc,#0x0013
      call posicionsigtile
      ld a,(hl)
      cp #0
      jp nz,final
      ld hl ,#_entity_jugador
      inc hl
      inc hl
      ld a,(hl)
      inc a
      inc a

      and #0b00000111
      or a
      jp nz, pasarr
      ld a ,#0
      ld bc,#0x0027
      call posicionsigtile
      ld a,(hl)
      cp #0
      jp nz,final
      
      pasarr:
      call posiciontile
      push hl

      ld hl,#_entity_jugador
      inc hl
      ld a,(hl)
      and #0b00000011
      or a
      jp nz, no_actu
      ld a,#1
      call actualiztilemenos
      no_actu:
      ld hl, #_entity_jugador
      ld e ,#0 ;y
      ld d, #2 ;x
      ld c, #0x00
      call _entity_update_pos
      push af
      cp #0xff
      jp nz,noactuiz
      call mirar
      cp #1
      jp z,noactuiz
      ld b,#1
      call actmirar
      call cambiar_anim_entity_jugador
      noactuiz:
      pop af
      cp #0xff
      jp z, finalhl
      pop de
      ld hl,#_posicion_jugador
      ld (hl),d
      inc hl
      ld (hl),e

   ret
   bajo:
      ld hl ,#_entity_jugador
      inc hl
      inc hl
      ld a,(hl)
      inc a
      inc a
      inc a
      inc a
      and #0b00000111
      or a
      jp nz, pasaba
      ld a ,#0
      ld bc,#0x0028
      call posicionsigtile
      ld a,(hl)
      cp #0
      jp nz,final

      ld hl ,#_entity_jugador
      inc hl
      ld a,(hl)
      and #0b00000011
      or a
      jp z, s
      ld a ,#0
      ld bc,#0x0029
      call posicionsigtile
      ld a,(hl)
      cp #0
      jp nz,final
      s:
      ld hl ,#_entity_jugador
      inc hl
      ld a,(hl)
      inc a
      and #0b00000011
      or a
      jp z, pasaba
      ld a ,#0
      ld bc,#0x0029
      call posicionsigtile
      ld a,(hl)
      cp #0
      jp nz,final
      pasaba:      
      ld hl, #_entity_jugador
      ld e ,#1 ;y
      ld d, #0 ;x
      ld c, #0x91
      call _entity_update_pos
      push af
      call mirar
      cp #4
      jp z,noactubaj
      ld b,#4
      call actmirar
      call cambiar_anim_entity_jugador      
      
      noactubaj:
      pop af
      cp #0xff
      jp nz,final
      ld hl,#_entity_jugador
      inc hl
      inc hl
      ld a,(hl)
      and #0b00000111
      or a
      jp nz, final
      ld a,#0x14
      call actualiztilemas
   ret
   arriba:
      ld hl ,#_entity_jugador
      inc hl
      inc hl
      ld a,(hl)
      dec a
      dec a
      dec a
      dec a

      and #0b00000111
      or a
      jp nz, pasar
      ld a ,#1
      ld bc,#0x0014
      call posicionsigtile      
      ld a,(hl)      
      cp #0
      jp nz,final
      ld hl ,#_entity_jugador
      inc hl
      ld a,(hl)
      and #0b00000011
      or a
      jp nz, sx
      ld hl ,#_entity_jugador
      inc hl
      ld a,(hl)
      inc a
      and #0b00000011
      or a
      jp z, pasar
      sx:
      ld a ,#1
      ld bc,#0x0013
      call posicionsigtile
      ld a,(hl)
      cp #0
      jp nz,final
      pasar:
      call posiciontile
      push hl

      ld hl,#_entity_jugador
      inc hl
      inc hl
      ld a,(hl)
      and #0b00000111
      or a
      jp nz, no_actu2
      ld a,#0x14
      call actualiztilemenos
      no_actu2:
      push af
      ld hl, #_entity_jugador
      ld e ,#2 ;y
      ld d, #0 ;x
      ld c, #0x04
      call _entity_update_pos
      push af
      call mirar
      cp #8
      jp z,noactuarr
            ld b,#8
      call actmirar
      call cambiar_anim_entity_jugador
      noactuarr:
      pop af
      cp #0xff
      jp z, finalhl2
      pop af
      cp #0xFF
      jp nz, finalhl
      pop de
      ld hl,#_posicion_jugador
      ld (hl),d
      inc hl
      ld (hl),e
   ret
mirar:
   ld hl,#_entity_jugador
   ld de,#0x0005
   add hl,de
   ld a,(hl)

ret
mirarene:
   call actualenemigo
   ld de,#0x0005
   add hl,de
   ld a,(hl)

ret
finalhl:
   pop hl
ret
finalhl2:
   pop hl
   pop af
ret
finalizhl:
   pop hl
   jp iz
ret
finalizhl2:
   pop hl
   pop af
   jp iz
ret

   compatack:

   ld de,#_entity_ataque+3
   ld a,(de)
   or a 
   jp nz, final
      call atack
   ret
   atack:
   ld de,#_entity_ataque
   ld a,#3
   ld (de),a
   ld de,#_entity_ataque+3
   ; ld hl,#3
   ; add de,hl
   ld a ,#15
   ld (de),a
   dec de
   dec de
   ld bc , #_entity_jugador
   ld hl ,#5
   add hl,bc
   ld a,(hl)
      cp #1;izquierda
      jp nz,x2
      ld bc , #_entity_jugador
      inc bc
      ld a ,(bc)
      sub #SP_ATAQUE_W
      dec a
      ld (de),a
      inc bc
      ld a ,(bc)
      inc de
      ld (de),a
      call colisionata
      ex de,hl
      ld a,(hl)
      cp #0
      jp nz,col
      ld bc,#0x14
      add hl,bc
      ld a,(hl)
      cp #0
      ret z
      jp col
      x2:;derecha
      cp #2
      jp nz,y
      ld bc , #_entity_jugador
      inc bc
      ld a ,(bc)
      add #SP_PERSONAJE_W
      inc a
      ld (de),a
      inc bc
      ld a ,(bc)
      inc de
      ld (de),a
      call colisionata
      ex de,hl
      inc hl
      ld a,(hl)
      cp #0
      jp nz,col
      ld bc,#0x14
      add hl,bc
      ld a,(hl)
      cp #0
      ret z
      col:
      ld de,#_entity_ataque
      ld a,#0xff
      ld (de),a
      ld de,#_entity_ataque+3
      ld a ,#0
      ld (de),a
      ret
   y:
      ld bc , #_entity_jugador
      ld hl ,#5
      add hl,bc
      ld a,(hl)
      cp #8;arriba
      jp nz,y2
      ld bc , #_entity_jugador
      inc bc
      ld a ,(bc)
      ld (de),a
      inc bc
      ld a ,(bc)
      sub #SP_ATAQUE_H
      dec a
      inc de
      ld (de),a
      call colisionata
      ex de,hl
      ld a,(hl)           
      cp #0
      jp nz,col
      inc hl
      ld a,(hl)
      cp #0
      ret z
      jp col
      y2:;abajo
      ld bc , #_entity_jugador
      inc bc
      ld a ,(bc)
      ld (de),a
      inc bc
      ld a ,(bc)
      add #SP_PERSONAJE_H
      inc a
      inc de
      ld (de),a
      call colisionata
      ex de,hl
      ld bc,#0x14
      add hl,bc
      ld a,(hl)
      cp #0
      jp nz,col
      inc hl
      ld a,(hl)
      cp #0
      ret z
      jp col
   ret
   final:
ret

finaldisp:
   call actualenemigo
   push hl
   cp #1
   jp z, magob
   call render_fondo_borrado_slime
      pop hl
   
   call render_fondo_borrado_vida
   jp eliminardis
   magob:
   call render_fondo_borrado
   pop hl
   
   call render_fondo_borrado_vida
   jp eliminardis
ret
posiciontile:
   ld hl, #_posicion_jugador
   ld d,(hl)
   inc hl
   ld l,(hl)
   ld h,d
   ret
posiciontileata:

   ld d,(hl)
   inc hl
   ld l,(hl)
   ld h,d
   ret
posiciontileene:
  
   call actualposdaenemigo
   ld d,(hl)
   inc hl
   ld l,(hl)
   ld h,d
   ret
posicionsigtile:
   ld hl, #_posicion_jugador
   ld d,(hl)
   inc hl
   ld l,(hl)
   ld h,d
   cp #1
   jp z,negativo
   add hl,bc
   ret
   negativo:
   sbc hl,bc
ret

actualposdaenemigo:
   call actualenemigo
   ld de,#0x000A
   add hl,de
   ret
posicionsigtileene:
   call actualposdaenemigo
   ld d,(hl)
   inc hl
   ld l,(hl)
   ld h,d
   cp #1
   jp z,negativoene
   add hl,bc
   ret
   negativoene:
   sbc hl,bc
ret
actualiztilemas:
   ld hl,#_posicion_jugador
   ld b,(hl)
   inc hl
   ld c,(hl)
   buclemas:
   inc bc
   dec a
   jp nz,buclemas

   ld (hl),c
   dec hl
   ld (hl),b
ret
actualiztilemasene:
   call actualposdaenemigo
   ld b,(hl)
   inc hl
   ld c,(hl)
   buclemasene:
   inc bc
   dec a
   jp nz,buclemasene

   ld (hl),c
   dec hl
   ld (hl),b
ret
actualiztilemenos:
   ld hl,#_posicion_jugador
   ld b,(hl)
   inc hl
   ld c,(hl)
   buclemenos:
   dec bc
   dec a
   jp nz,buclemenos
   ld (hl),c
   dec hl
   ld (hl),b
   ld a,#0xff
ret
actualiztilemenosene:
   call actualposdaenemigo
   ld b,(hl)
   inc hl
   ld c,(hl)
   buclemenosene:
   dec bc
   dec a
   jp nz,buclemenosene
   ld (hl),c
   dec hl
   ld (hl),b
   ld a,#0xff
ret



recorrerEne::
   ld hl,#_num_enemies
   ld a ,(hl)
   or a
   jp z,final
   ld d,a
   xor a
   ld c,#0
   bucleen:
   ld a,c
   ld hl,#_act_enemy
   ld (hl),a
   push de
   call actualenemigo
   ld a,(hl)
   cp #5
   jp nz,mago
   call actualenemigo
   ld de ,#0x0006
   add hl,de
   ld a,(hl)
   cp #5
   jp nc,siguenen
   call moviene
   jp siguenen
   mago:
   call movimientoEne
   siguenen:
   pop de
   ld hl,#_act_enemy
   ld a,(hl)
   ld bc,#TAM_ENTITY_ENEMIGO_TOTAL
   add a,c
   ld c,a
   dec d
   ld a,d
   or a
   jp nz,bucleen
ret
movimientoEne:
      call actualenemigo
      ld a,(hl)
      cp #0xff
      jp z,final

      ld de,#POS_VELOCIDAD
      add hl,de
      ld a,(hl)
      or a 
      jp nz,noentrar
      call rotaene
      call actualenemigo
      ld de,#POS_VELOCIDAD
      add hl,de
      ld (hl),#0x40;choque 140
      noentrar:
      ld a,(hl)
      dec a
      ld (hl),a
      call actualenemigo

      ld de,#7
      add hl ,de
      ld a,(hl)
      or a 
      jp nz,moverd
      ld a,(_nivel)
      cp #1
      ret z
      call dispara
      ret
      moverd:
      call moverdisparo
    ret
finalds:
   pop hl
ret
actualenemigo::
   ld hl,#_act_enemy
   ld d,#0
   ld e,(hl)
   ld hl,#_entity_enemigos
   add hl,de
   
ret
actualdisparo::
   ld hl,#_act_enemy
   ld d,#0
   ld e,(hl)
   ld hl,#_entity_enemigos
   add hl,de
   ld de,#0x0007
   add hl,de
ret
rellenar:
   inc bc
   inc hl
   ld a,(bc)
   ld (hl),a
   ret
   rellenarmed:
   inc bc
   inc hl
   ld a,(bc)
   add d
   ld (hl),a
   ret
dispara:
   call actualdisparo
   ex de,hl
   push de
   call actualenemigo
   pop de
   inc de
   inc hl
   ld a,(hl)
   ld (de),a
   inc de
   inc hl
   ld a,(hl)
   ld (de),a

   call actualenemigo
   ld de,#5
   add hl,de
   ld a,(hl)
   disparizq:
   cp #1
   jp nz,disparder
   push hl
   call actualenemigo

   ld d,h
   ld e,l
   ld hl ,#_entity_jugador
   inc de
   inc hl
   ld a,(de)
   ld c,(hl)   
   cp c
   jp c,finalds
   inc de
   ex de, hl
   ld c ,(hl)
   ex de,hl
   ld b ,#SP_ENEMIGO_H
   inc hl
   ld a,#SP_PERSONAJE_H
   ld (_buclee),a
   call colision
   cp #1
   jp nz,finalds
   pop hl
   inc hl
   inc hl
   ld (hl),#1
   push hl
   call actualenemigo
   ld b,h
   ld c,l
   pop hl
   call rellenar
   ld d,#SP_ENEMIGO_HM
   call rellenarmed
   call tilenedis
   ret
   disparder:
   cp #2
   jp nz,dispararr
   push hl
   call actualenemigo
   ld d,h
   ld e,l
   ld hl ,#_entity_jugador
   inc de
   inc hl
   ld a,(de)
   ld c,(hl)   
   cp c
   jp nc,finalds
   inc de
   ex de, hl
   ld c ,(hl)
   ex de,hl
   ld b ,#SP_ENEMIGO_H
   inc hl

   ld a,#SP_PERSONAJE_H
   ld (_buclee),a
   call colision
   cp #1
   jp nz,finalds
   pop hl
   inc hl
   inc hl
   ld (hl),#2
   push hl
   call actualenemigo
   ld b,h
   ld c,l
   pop hl
   call rellenar
   ld d,#SP_ENEMIGO_HM
   call rellenarmed
   call tilenedis
   ret
   dispararr:
   ld a,(hl)
   cp #8
   jp nz,disparaba
   push hl
   call actualenemigo
   ld d,h
   ld e,l
   ld hl ,#_entity_jugador
   inc de
   ex de, hl
   ld c ,(hl)
   ex de,hl
   push de
   ld b ,#SP_ENEMIGO_W

   inc hl
   push hl
   ld a,#SP_PERSONAJE_W
   ld (_buclee),a
   call colision
   pop hl
   pop de
   cp #1
   jp nz,finalds
   inc de
   inc hl
   ld a,(de)
   ld c,(hl)  
   cp c
   jp c,finalds
   pop hl
   inc hl
   inc hl
   ld (hl),#3
   push hl
   call actualenemigo
   ld b,h
   ld c,l
   pop hl
   ld d,#SP_ENEMIGO_WM
   call rellenarmed
   call rellenar
   call tilenedis
   ret
   disparaba:
   push hl
   call actualenemigo
   ld d,h
   ld e,l
   ld hl ,#_entity_jugador
   inc de
   ex de, hl
   ld c ,(hl)
   ex de,hl
   ld b ,#SP_ENEMIGO_W
   inc hl
   push de
   push hl
   ld a,#SP_PERSONAJE_W
   ld (_buclee),a
   call colision
   pop hl
   pop de

   cp #1
   jp nz,finalds
   inc de
   inc hl
   ld a,(de)
   ld c,(hl)  
   cp c
   jp nc,finalds
   pop hl
   inc hl
   inc hl
   ld (hl),#4
   push hl
   call actualenemigo
   ld b,h
   ld c,l
   pop hl
   ld d,#SP_ENEMIGO_WM
   call rellenarmed
   call rellenar
   call tilenedis
   ret
moverdisparo:

   call actualenemigo

   ld de,#7
   add hl ,de
   ld a,(hl)
   cp #1
   jp z,izq
   cp #2
   jp z,der
   cp #3
   jp z,arr
   jp aba

   izq:
   call actualdisparo
   inc hl
   ld a,(hl)
   and #0b00000011
   or a
   jp nz, noac
   ld a ,#1
   ld bc,#0x0001
   call posicionsigtileene
   ld a,(hl)
   cp #0
   jp nz,eliminardis
   ld a,#1
   call actualiztilemenosene
   noac:
   call actualdisparo
   inc hl
   ld a,(hl)
   dec a
   or a
   
   jp nz, moverfin
   jp eliminardis
   der:
   call actualdisparo
   inc hl
   ld a,(hl)
   and #0b00000011
   or a
   jp nz, noacder
   ld a ,#0
   ld bc,#0x0001
   call posicionsigtileene
   ld a,(hl)
   cp #0
   jp nz,eliminardis
   ld a ,#1
   call actualiztilemasene
   noacder:
   call actualdisparo
   inc hl
   ld a,(hl)

   inc a
   cp #0x49
   jp nz,moverfin
   jp eliminardis

   arr:
   call actualdisparo
   inc hl
   inc hl
   ld a,(hl)
   and #0b00000111
   or a
   jp nz, noct
   ld a ,#1
   ld bc,#0x0014
   call posicionsigtileene      
   ld a,(hl)      
   cp #0
   jp nz,eliminardis
  
   ld a,#0x14
   call actualiztilemenosene
   noct:
   call actualdisparo
   inc hl
   inc hl
   ld a,(hl)
   dec a
   or a
   jp z,eliminardis
   dec a
   or a
   jp nz,moverfin
   jp eliminardis

   aba:
   call actualdisparo
   inc hl
   inc hl
   ld a,(hl)
   and #0b00000111
   or a
   jp nz, noct1
    ld a ,#0
   ld bc,#0x0014
   call posicionsigtileene
   ld a,(hl)
   cp #0
   jp nz,eliminardis
   

   ld a,#0x14
   call actualiztilemasene
   noct1:
   call actualdisparo
   inc hl
   inc hl
   ld a,(hl)
   inc a
   cp #0xB9
   jp z,eliminardis
   inc a
   cp #0xB9
   jp nz,moverfin
   eliminardis:
   call actualenemigo

   ld de,#7
   add hl ,de
   ld (hl),#0
   call render_fondo_borrado_shot
   ret
   moverfin:
   ld (hl),a
   ret
rotaene:
   call actualenemigo
   ld de,#5
   add hl,de
   ld a,(hl)
   cp #1
   jp z,mirarr
   cp #2
   jp z, mirbaj
   ld a,(hl)
   cp #8
   jp z,mirder
   mirizq:
      ld (hl),#0
      call actualenemigo
      ld de,#5
      add hl,de
      ld (hl),#1
      call actualenemigo
      call cambiar_anim_entity_enemigo
   jp mirfin
   mirder:
      ld (hl),#0
      call actualenemigo
      ld de,#5
      add hl,de
      ld (hl),#2
      call actualenemigo
      call cambiar_anim_entity_enemigo
   jp mirfin
   mirarr:
      ld (hl),#0
      call actualenemigo
      ld de,#5
      add hl,de
      ld (hl),#8
      call actualenemigo
      call cambiar_anim_entity_enemigo
    jp mirfin
   mirbaj:
      ld (hl),#0
      call actualenemigo
      ld de,#5
      add hl,de
      ld (hl),#4
      call actualenemigo
      call cambiar_anim_entity_enemigo

mirfin:
ret
moviene: ;Slime 
   call actualenemigo
   ld de,#0x0007
   add hl,de
   ld (hl),#0x05
   call actualenemigo
   ld de,#0x0004
   add hl,de
   ld a,(hl)
   or a
   jp nz, nomove
   ld a,#8
   ld (hl),a
   call actualenemigo
   inc hl
   ld a ,(hl)
   ld hl, #_entity_jugador
   inc hl
   ld c ,(hl)
   sub c
   jp nz,sigue
   jp iz
   sigue:
   jp c,sum    ;izquierda
      call actualenemigo
      inc hl
      ld a,(hl)
      and #0b00000011
      or a
      jp nz, spasaiz
      ld a ,#1
      ld bc,#0x0001
      call posicionsigtileene
      ld a,(hl)
      cp #0
      jp nz,iz
      call actualenemigo
      inc hl
      inc hl
      ld a,(hl)
      dec a
      dec a

      and #0b00000111
      or a
      jp z, slig2
      call actualenemigo
      inc hl
      inc hl
      ld a,(hl)
      and #0b00000111
      or a
      jp nz, slig
      slig2:
      ld a ,#1
      ld bc,#0x0015
      call posicionsigtileene
      ld a,(hl)
      cp #0
      jp nz,iz
      slig:
      ld a ,#0
      ld bc,#0x0013
      call posicionsigtileene
      ld a,(hl)
      cp #0
      jp nz,iz
      call actualenemigo
      inc hl
      inc hl
      ld a,(hl)
      inc a
      inc a

      and #0b00000111
      or a
      jp nz, spasaiz
      ld a ,#0
      ld bc,#0x0027
      call posicionsigtileene
      ld a,(hl)
      cp #0
      jp nz,iz
      
      spasaiz::
      call posiciontileene
      push hl

      call actualenemigo
      inc hl
      ld a,(hl)
      and #0b00000011
      or a
      jp nz, sno_actu
      ld a,#1
      call actualiztilemenosene
      sno_actu:
      push af
      call actualenemigo
      ld e ,#0 ;y
      ld d, #2 ;x
      ld c, #0x0
      call _entity_update_pos
      push af
      call slimeactpos
      
      call mirarene
      cp #1
      jp z,noactualiz
      ld b,#1
      call actmirarene

      call actualenemigo
      call cambiar_anim_entity_enemigo
      noactualiz:
      pop af
      cp #0xff
      jp z, finalizhl2
      pop af
      cp #0xff
      jp nz, finalizhl
      pop de      
      call actualposdaenemigo
      ld (hl),d
      inc hl
      ld (hl),e
   jp iz
   sum:;derecha
    ld a ,#0
      call actualenemigo
      inc hl
      ld a,(hl)
      inc a
      inc a
      and #0b00000011
      or a
      jp nz, ders
      ld a ,#0
      ld bc,#0x0002
      call posicionsigtileene
      ld a,(hl)
      cp #0
      jp nz,iz
      ld a ,#0
      ld bc,#0x0016
      call posicionsigtileene
      ld a,(hl)
      cp #0
      jp nz,iz
      ders:
      call actualenemigo
      inc hl
      inc hl
      ld a,(hl)
      dec a
      dec a
      and #0b00000111
      or a
      jp z, sli2
      call actualenemigo
      inc hl
      inc hl
      ld a,(hl)
      and #0b00000111
      or a
      jp nz, sli
      sli2:
      ld a ,#1
      ld bc,#0x0012
      call posicionsigtileene    
      ld a,(hl)
      cp #0
      jp nz,slimeder
      sli:
       call actualenemigo
      inc hl
      inc hl
      ld a,(hl)
      inc a
      inc a
      and #0b00000111
      or a
      jp nz, sderrr
      ld a ,#0
      ld bc,#0x002A
      call posicionsigtileene
      ld a,(hl)
      cp #0
      jp z,sderrr
      jp iz
      slimeder:
      call actualenemigo
      inc hl
      ld a,(hl)
      
      and #0b00000011
      or a
      jp z,iz
      sderrr:
      call actualenemigo
      ld e ,#0 ;y
      ld d, #1 ;x
      ld c, #0x48
      call _entity_update_pos
      push af
      call slimeactpos
      
      call mirarene
      jp z,noactuderene
      ld b,#2
      call actmirarene

      call actualenemigo
      call cambiar_anim_entity_enemigo
      noactuderene:
      pop af
      cp #0xff
      jp nz,iz
      call actualenemigo
      inc hl
      ld a,(hl)
      and #0b00000011
      or a
      jp nz, iz
      ld a,#1
      call actualiztilemasene
   jp iz
   iz:
   call actualenemigo
   inc hl
   inc hl
   ld a ,(hl)
   ld hl, #_entity_jugador
   inc hl
   inc hl
   ld c ,(hl)   
   sub c
   jp nz,sigue2
   ret
   sigue2:
   jp c,sum2 ;arriba
      call actualenemigo
      inc hl
      inc hl
      ld a,(hl)
      dec a
      dec a
      dec a
      dec a
      and #0b00000111
      or a
      jp nz, spasar
      ld a ,#1
      ld bc,#0x0014
      call posicionsigtileene      
      ld a,(hl)      
      cp #0
      jp nz,final
      call actualenemigo
      inc hl
      ld a,(hl)
      and #0b00000011
      or a
      jp nz, ssx
      call actualenemigo
      inc hl
      ld a,(hl)
      inc a
      and #0b00000011
      or a
      jp z, spasar
      ssx:
      ld a ,#1
      ld bc,#0x0013
      call posicionsigtileene
      ld a,(hl)
      cp #0
      jp nz,final
      ld a,(hl)      
      cp #0
      jp nz,final
      call actualenemigo
      inc hl
      ld a,(hl)
      and #0b00000011
      or a
      jp z, sssx
      call actualenemigo
      inc hl
      ld a,(hl)
      inc a
      and #0b00000011
      or a
      jp nz, spasar
      sssx:
      ld a ,#1
      ld bc,#0x0012
      call posicionsigtileene
      ld a,(hl)
      cp #0
      jp nz,final
      spasar:
      call posiciontileene
      push hl

      call actualenemigo
      inc hl
      inc hl
      ld a,(hl)
      and #0b00000111
      or a
      jp nz, sno_actu2
      ld a,#0x14
      call actualiztilemenosene
      sno_actu2:
      push af
      call actualenemigo
      ld e ,#2 ;y
      ld d, #0 ;x
      ld c, #0x0
      call _entity_update_pos
      push af
      call slimeactpos
      
      call mirarene
      cp #1
      jp z,noactuarrene
            ld b,#8
      call actmirarene
      call actualenemigo
      call cambiar_anim_entity_enemigo
      noactuarrene:
      pop af
      cp #0xff
      jp z, finalhl2
      pop af
      cp #0xFF
      jp nz, finalhl
      pop de
      call actualposdaenemigo
      ld (hl),d
      inc hl
      ld (hl),e
      ret
 sum2:;bajo
      call actualenemigo
      inc hl
      inc hl
      ld a,(hl)
      inc a
      inc a
      inc a
      inc a
      and #0b00000111
      or a
      jp nz, spasaba
      ld a ,#0
      ld bc,#0x0028
      call posicionsigtileene
      ld a,(hl)
      cp #0
      jp nz,final

      call actualenemigo
      inc hl
      ld a,(hl)
      
      and #0b00000011
      or a
      jp z, ss
      ld a ,#0
      ld bc,#0x0029
      call posicionsigtileene
      ld a,(hl)
      cp #0
      jp nz,final
      ss:
      call actualenemigo
      inc hl
      ld a,(hl)
      inc a
      and #0b00000011
      or a
      jp z, ss1
      ld a ,#0
      ld bc,#0x0029
      call posicionsigtileene
      ld a,(hl)
      cp #0
      jp nz,final
      call actualenemigo
      inc hl
      ld a,(hl)
      
      and #0b00000011
      or a
      jp nz, ss1
      ld a ,#0
      ld bc,#0x002A
      call posicionsigtileene
      ld a,(hl)
      cp #0
      jp nz,final
      ss1:
      call actualenemigo
      inc hl
      ld a,(hl)
      inc a
      and #0b00000011
      or a
      jp nz, spasaba
      ld a ,#0
      ld bc,#0x002A
      call posicionsigtileene
      ld a,(hl)
      cp #0
      jp nz,final
      spasaba:   
      call actualenemigo
      ld e ,#1 ;y
      ld d, #0 ;x
      ld c, #0xB9
      call _entity_update_pos
      push af
      call slimeactpos
      
      call mirarene
      cp #4
      jp z,noactubajene
      ld b,#4
      call actmirarene
      call actualenemigo
      call cambiar_anim_entity_enemigo      
      
      noactubajene:
      pop af
      cp #0xff
      jp nz,final
      call actualenemigo
      inc hl
      inc hl
      ld a,(hl)
      and #0b00000111
      or a
      jp nz, final
      ld a,#0x14
      call actualiztilemasene
   
   ret
   nomove:
      dec a
      ld (hl),a
   ret
slimeactpos:
   call actualenemigo
   inc hl
   ld a,(hl)
   inc hl
   ld c,(hl)
   ld de,#0x0006
   add hl,de
   ld (hl),a
   inc hl
   ld (hl),c
ret
recorrerEnecol::
   ld hl,#_num_enemies
   ld a ,(hl)
   or a
   jp z,final
   ld d,a
   xor a
   ld c,#0
   bucleene:
   ld a,c
   ld hl,#_act_enemy
   ld (hl),a
   push de
   call colisionEne
   pop de
   ld hl,#_act_enemy
   ld a,(hl)
   ld bc,#TAM_ENTITY_ENEMIGO_TOTAL
   add a,c
   ld c,a
   dec d
   ld a,d
   or a
   jp nz,bucleene
ret

colisionEne:
   call actualenemigo
   ld de,#6
   add hl, de
   ld a,(hl)
   or a
   jp nz,finalinv
   call actualenemigo
   ld a,(hl)
   cp #0xff
   jp z,final
   call actualenemigo
   inc hl
   ld c ,(hl)
   ld b ,#SP_ENEMIGO_W

   ld hl, #_entity_ataque
   ld a,(hl)
   cp #0xff
   jp z,final
   inc hl
   ld a,#SP_PERSONAJE_W
   ld (_buclee),a
   call colision
   or a
   jp z,finn
      call actualenemigo
      inc hl
      inc hl
      ld c ,(hl)
      ld b ,#SP_ENEMIGO_H
      ld hl, #_entity_ataque
      inc hl
      inc hl
   
      ld a ,#SP_PERSONAJE_H
      ld (_buclee),a
      call colision
      or a
      jp z,finn
      call actualenemigo
      call entity_update_vida
      call actualenemigo
      
      ld a,(hl)
      cp #0xff
      jp nz,nomuere
      ld a,(hl)
      cp #0xff
      jp z, finaldisp
      nomuere:
      call invencible
   finn:
ret
   finalinv:
   dec a
   ld (hl),a
   ret
invencible:
      ld de,#6
      add hl,de
      ld (hl),#0x20
colision::   
   bu:
      ld d ,(hl) 
      ld a,(_buclee)
      ld e,a
      bu2: 
         ld a,c
         cp d
         jp nz , noze
            ld a,#1
            ret
         noze:
            inc d
            dec e
            ld a,e
            or a
      jp nz,bu2
         inc c
         dec b
         ld a, b
         or a
   jp nz, bu
   xor a
ret
actuatack::
   ld hl, #_entity_ataque
   ld a,(hl)
   cp #0xff
   ret z
   ld de, #_entity_ataque+3
   ld a,(de)
   or a
   jp z, finalat
   dec a
   ld (de),a

ret
finalat:
   
   ld de, #_entity_ataque
   ld a,#0xFF
   ld (de),a
   ld hl ,#_entity_ataque
   call render_fondo_borrado

ret
personajecol::
   ld hl,#_entity_jugador
   ld de,#0x0006
   add hl,de
   ld a ,(hl)
   or a
   jp nz,finn
   ld hl,#_num_enemies
   ld a ,(hl)
   or a
   jp z,final
   ld d,a
   xor a
   ld c,#0
   bucleene3:
   ld a,c
   ld hl,#_act_enemy
   ld (hl),a
   push de
   call colisionPer
   pop de
   ld hl,#_act_enemy
   ld a,(hl)
   ld bc,#TAM_ENTITY_ENEMIGO_TOTAL
   add a,c
   ld c,a
   dec d
   ld a,d
   or a
   jp nz,bucleene3

ret

colisionPer: 
   call actualenemigo
   ld de,#0x0007
   add hl,de
   ld a,(hl)
   cp #0x0
   jp z,final
   inc hl
   ld c ,(hl)
   ld b ,#SP_SHOT_W
   ld hl, #_entity_jugador
   ld a,(hl)
   cp #0xff
   jp z,final
   inc hl
   ld a,#SP_PERSONAJE_W
   ld (_buclee),a
   call colision
   or a
   jp z,finn
      call actualenemigo
      ld de,#0x0007
      add hl,de
      inc hl
      inc hl
      ld c ,(hl)
      ld b ,#SP_SHOT_H
      ld hl, #_entity_jugador
      inc hl
      inc hl
   
      ld  a ,#SP_PERSONAJE_H
      ld (_buclee),a
      call colision
      or a
      jp z,finn
      ld hl,#_entity_jugador
      call entity_update_vida
      call invencible
      call actualenemigo
      ld a,(hl)
      cp #5
      ret z
      jp eliminardis



ret